%This script draws a graph on the screen using responses from a Cedrus
%Rb-730 box set to Rb-series protcol at 19200 baud rate
%Dip Switches: 1up 2up 3down 4down
%It can easily be modified to suit any Cedrus Response Box based on the
%config_serial function below

%Configure the serial port: Com port, Baud rate, Parity, StopBits, Byte Size
%Set the protocol to Rb-series on the Cedrus box
config_serial(4,19200,0,0,8)

start_cogent

check = 0;
tension = 0;
bytes = 0;
draw = 1;

%Draw the graph on screen
barh([tension]);xlim([0 255]);set(gca,'Xtick',[ ]);set(gca,'Ytick',[ ]);
drawnow;
    
while (check == 0)
    
    %Every loop read the byte posted and use lastserialbyte to determine
    %its value, given by b
    
    readserialbytes(4);
    [b,c] = lastserialbyte(4);
    
    draw = 1;
    
    if b == 253
        bytes = 253;
    end

    if b == 251
        bytes = 251;
    end

    if b == 239
        check = 1;
    end
    
    if b == 255 %Put value for exiting out of the program
        bytes = 1;
    end
    
    if bytes == 251 %Put value for growing the bar
        
        tension = tension + 2.5;

        if tension > 255
            tension = 255;
        end
        
        if tension < 0
            tension = 0;
        end

        barh([tension]);xlim([0 255]);set(gca,'Xtick',[ ]);set(gca,'Ytick',[ ]);
        drawnow;
        
    end

    if bytes == 253 %Put value for shrinking the bar
        
        tension = tension - 1.25;

        if tension > 255
            tension = 255;
        end
        
        if tension < 0
            tension = 0;
        end

        barh([tension]);xlim([0 255]);set(gca,'Xtick',[ ]);set(gca,'Ytick',[ ]);
        drawnow;
        
    end

end

stop_cogent